// File.h: interface for the CFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILE_H__E6568972_0E78_4FA5_BD4D_E1125ADA9BE5__INCLUDED_)
#define AFX_FILE_H__E6568972_0E78_4FA5_BD4D_E1125ADA9BE5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef _FSTREAM_
#error "You forgot to #include <fstream>!"
#endif

#ifndef _IOSTREAM_
#error "You forgot to #include <iostream>!"
#endif

#ifndef _STRING_
#error "You forgot to #include <string>!"
#endif

class CFile  
{
public:
	CFile& operator =(const CFile &pFile);
	DWORD GetBufferSize() const;
	const BYTE* GetBuffer();
	std::string GetFieldName() const;
	std::string GetClientFilename() const;
	std::string GetContentType() const;
	bool Save( std::string filename );
	int GetData( BYTE* lpData, size_t count );
	CFile();
	CFile(std::string m_name,std::string filename,std::string content,BYTE* data,unsigned long datasize);
	virtual ~CFile();

protected:
	std::string m_content;
	std::string m_filename;
	std::string m_name;
	unsigned long m_datasize;
	BYTE* m_data;
private:
	bool m_bDeallocate;
};

#endif // !defined(AFX_FILE_H__E6568972_0E78_4FA5_BD4D_E1125ADA9BE5__INCLUDED_)
