// ISAPIUploadDemo.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "QueryString.h"
#include "WebForm.h"
#include "MultipartForm.h"

std::string g_sCurPath;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  dwReason, 
                       LPVOID lpReserved
					 )
{
	if( dwReason == DLL_PROCESS_ATTACH )
	{
		/// get the current path
		char szModule[256];
		memset( szModule, 0, 256 );
		GetModuleFileName( (HMODULE)hModule, szModule, 256 );
		/// remove the file name
		g_sCurPath = szModule;
		g_sCurPath = g_sCurPath.substr( 0, g_sCurPath.rfind( "\\" ) + 1 );
	}
    return TRUE;
}

BOOL WINAPI GetExtensionVersion(HSE_VERSION_INFO *pVer)
{
	pVer->dwExtensionVersion = MAKELONG( HSE_VERSION_MINOR, HSE_VERSION_MAJOR );;
	strncpy(pVer->lpszExtensionDesc, "ISAPI Upload Demo Extension", HSE_MAX_EXT_DLL_NAME_LEN);
	return HSE_STATUS_SUCCESS;
}

DWORD WINAPI HttpExtensionProc(EXTENSION_CONTROL_BLOCK *pECB)
{
	CQueryString QueryString( pECB );
	char page[16384]; /// buffer for page

	QueryString.Parse();
	memset(page,0,16384);

	if( QueryString["multi"] == "multi" )
	{
		CMultipartForm Form( pECB );
		CFile File;
		Form.Parse();

		if( Form.GetFirstFile( &File ) )
		{
			std::string filename = g_sCurPath + File.GetClientFilename();
			File.Save(filename);

			sprintf(page,"<html>\r\n<head><title>ISAPI Upload Demo</title></head>\r\n"
							"<body>You Wrote: %s<br>\r\nYou selected: %s<br>\r\n"
							"You uploaded the file: <a href=\"%s\">%s</a>\r\n<br>"
							"</body></html>", 
							Form["textest"].c_str(), 
							Form["selecttest"].c_str(),
							File.GetClientFilename().c_str(),
							File.GetClientFilename().c_str() );
		}
		else
		{
			sprintf(page,"<html>\r\n<head><title>ISAPI Upload Demo</title></head>\r\n"
							"<body>You Wrote: %s<br>\r\nYou selected: %s<br>\r\n"
							"</body></html>", 
							Form["textest"].c_str(), 
							Form["selecttest"].c_str() );
		}
	
	}
	else if( QueryString["post"] == "post" )
	{
		CWebForm Form( pECB );
		Form.Parse();
		sprintf(page,"<html>\r\n<head><title>ISAPI Upload Demo</title></head>\r\n"
						"<body>You Wrote: %s<br>\r\nYou selected: %s<br>\r\n"
						"</body></html>", 
						Form["textest"].c_str(), 
						Form["selecttest"].c_str() );

	}
	else
	{	/// Just Query Stirng was submitted
		sprintf(page,"<html>\r\n<head><title>ISAPI Upload Demo</title></head>\r\n"
						"<body>You Wrote: %s<br>\r\nYou selected: %s<br>\r\n"
						"</body></html>", 
						QueryString["textest"].c_str(), 
						QueryString["selecttest"].c_str() );
	}

	DWORD size = strlen(page);
	if( pECB->WriteClient(pECB->ConnID, (char*)page, &size, 0) )
		return HSE_STATUS_SUCCESS;
	return HSE_STATUS_ERROR;
}