// DataBuffer.h: interface for the CDataBuffer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATABUFFER_H__86320205_BE9E_4B63_B34C_A0C759AB5BF8__INCLUDED_)
#define AFX_DATABUFFER_H__86320205_BE9E_4B63_B34C_A0C759AB5BF8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDataBuffer
{
public:
	bool Copy(char* szData, size_t nSize);
	bool Copy( BYTE* pData, size_t nSize );
	DWORD FindNext( const char* szSub, DWORD dwPos = 0 );
	DWORD GetPos() const;
	void Seek( DWORD dwPos );
	bool IsEmpty() const;
	bool GetLine( char* szData, size_t nSize );
	void ToChar( char* szData, size_t nSize );
	DWORD Size() const;
	bool Append( BYTE* pData, size_t nDataSize);
	bool Allocate( DWORD dwSize );
	CDataBuffer();
	virtual ~CDataBuffer();

protected:
	void ByteToChar(const BYTE *pByte, char *pChar, size_t count);
	void CharToByte(const char *pChar, BYTE *pByte, size_t count);
	DWORD memfind(const BYTE *pSource, const BYTE *pSub, size_t nSourceSize, size_t nSubSize);
	BYTE* m_pBuffer;
	DWORD m_dwSize;
	DWORD m_dwPos;
};

#endif // !defined(AFX_DATABUFFER_H__86320205_BE9E_4B63_B34C_A0C759AB5BF8__INCLUDED_)
