// MultipartForm.h: interface for the CMultipartForm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MULTIPARTFORM_H__8EA974F3_B54E_4B6B_9B98_63B4B25495DF__INCLUDED_)
#define AFX_MULTIPARTFORM_H__8EA974F3_B54E_4B6B_9B98_63B4B25495DF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Check includes
#ifndef _VECTOR_
#error "You forgot to #include <vector>"
#endif

#ifndef _STRING_
#error "You forgot to #include <string>"
#endif

#include "WebForm.h" /// Base Class
#include "File.h"

class CMultipartForm : public CWebForm
{
public:
	bool GetNextFile(CFile* pFile);
	bool GetFirstFile(CFile* pFile);
	virtual void Parse();
	CMultipartForm(EXTENSION_CONTROL_BLOCK *pECB);
	virtual ~CMultipartForm();

protected:
	std::vector<CFile*> m_files;
	std::vector<CFile*>::iterator m_fileit;
};

#endif // !defined(AFX_MULTIPARTFORM_H__8EA974F3_B54E_4B6B_9B98_63B4B25495DF__INCLUDED_)
